/*
 *   FTP2Array: Downloads a text file via FTP and reads it into a vector.
 *   Copyright (C) 2002 Mark Andrew Wilson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  ominous_squirrel@hotmail.com
 *  http://www.cs.indiana.edu/~marawils/jab/
 */

package mawilson.file2array;

import mawilson.file2array.File2Array;
import com.enterprisedt.net.ftp.FTPException;
import com.enterprisedt.net.ftp.FTPClient;
import com.enterprisedt.net.ftp.FTPTransferType;
import com.enterprisedt.net.ftp.FTPConnectMode;
import java.io.IOException;
import java.util.StringTokenizer;
import java.util.Vector;

import java.io.*;


public class FTP2Array extends File2Array
{

    public static void main(String[] args)
    {
	FTP2Array ftp2array = null;
	
	try{ftp2array = new FTP2Array(args[0], args[1], args[2], args[3]);}
	catch(Exception e){System.err.println("FTP2Array error: " + e.toString());} // bleh
	
	for(int i = 0; i < ftp2array.getLength(); i++)
	  {
	      System.out.println(ftp2array.getLine(i));
	  }
	
    }

    public FTP2Array(String FTPsite, String filepath, String username, String password) throws FTPException, java.io.IOException
    {
		    
		FTPClient ftp = new FTPClient(FTPsite, 21);
		ftp.login(username, password);
		ftp.setType(FTPTransferType.ASCII);
		ftp.setConnectMode(FTPConnectMode.PASV);
		byte[] buf = ftp.get(filepath);
		this.readHer(buf);
		ftp.quit();
	
    }

    public FTP2Array(FTPClient openedFtp, String filepath) throws FTPException, IOException
    {
	byte[] buf = openedFtp.get(filepath);
	this.readHer(buf);
    }

    protected void readHer(byte[] in) throws java.io.IOException
    {
	StringTokenizer tokes = new StringTokenizer(new String(in), new String("\n"));
	lines = new Vector();
	while (tokes.hasMoreTokens()) 
	    {
		lines.addElement(tokes.nextToken());
	    }
	
    }

        
}
