/*
 *   File2Array: Downloads a URL and reads it into a vector.
 *   Copyright (C) 2002 Mark Andrew Wilson
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  ominous_squirrel@hotmail.com
 *  http://www.cs.indiana.edu/~marawils/jab/
 */

package mawilson.file2array;

import java.net.*;
import java.io.*;
import java.util.*;
import java.lang.ArrayIndexOutOfBoundsException;

public class File2Array
{
    protected Vector lines;
    
    public static void main(String[] args)
    {
	
	File2Array file2Array;
	try
	    {
		file2Array = new File2Array(args[0]);
	    }
	catch(IOException ex)
	    {
		System.err.println(ex.toString());
		return;
	    }
	
	for(int i = 0; i < file2Array.getLength(); i++)
	    {
		System.out.println(file2Array.toString());
	    }
    }

    public File2Array()
    {
	lines = new Vector();
    }
    
    public File2Array(URL tagfile) throws IOException
    {
	
	URL filename = tagfile;
	
	BufferedReader in = new BufferedReader(new InputStreamReader(filename.openStream()));
	this.readHim(in);
	
    }
    
    public File2Array(String tagfile) throws IOException 
    {
	URL filename;
	
	try
	    {
		filename = new URL(tagfile);
		
		BufferedReader in = new BufferedReader(new InputStreamReader(filename.openStream()));
		this.readHim(in);
	    }
	catch(MalformedURLException e)
	    {
		File file = new File(tagfile);
		fileConst(file);
	    }
	
    }
    
    public File2Array(File tagfile) throws FileNotFoundException, IOException
    {
	fileConst(tagfile);
    }
    
    private void fileConst(File tagfile) throws FileNotFoundException, IOException 
    {		
	final File filename = tagfile;
	
	BufferedReader in = new BufferedReader(new InputStreamReader(new FileInputStream(filename)));
	this.readHim(in);		
    }
        
    protected void readHim(BufferedReader in) throws java.io.IOException
    {
	lines = new Vector();
	String thisLine;
	int i = 0;
	while ((thisLine = in.readLine()) != null)
	    {
		lines.addElement(thisLine);
		i++;
	    }
	in.close();
    }
    
    public int getLength()
    {
	return lines.size();
    }
    
    public String getLine(int n) throws ArrayIndexOutOfBoundsException
    {
	String thisLine = (String) lines.elementAt(n);
	if (thisLine != null)
	    {return thisLine;}
	else
	    {throw new ArrayIndexOutOfBoundsException(n);}
    }

    public Vector getVector()
    {
	return lines;
    }
    
    public void insertLine(String line, int index)
    {
	lines.add(index, line);
    }

    public String toString()
    {
	String returnString = new String();

	for(int i = 0; i < this.getLength(); i++)
	    {
		String catMe = this.getLine(i).concat(new String("\n"));
		returnString = returnString.concat(catMe);
	    }
	return returnString;
    }

}
